#!/usr/bin/perl
#///////////////////////////////
#//          Counter          //
#//          Server           //
#//      Programmiert von     //
#//        Markus Bode        //
#//       www.osmodia.de      //
#//                           //
#//  Solange der Copyright-   //
#//  hinweis und der Link zu  //
#//    osmodia.de erhalten    //
#// bleibt, darf dieses Script//
#//      editiert werden.     //
#// Dieser Eintrag darf nicht //
#//     entfernt werden.      //
#//                           //
#//       Support unter       //
#//   http://www.osmodia.de   //
#//        und in der         //
#//           FAQ             //
#//                           //
#///////////////////////////////

use CGI::Carp "fatalsToBrowser";

require "config.cgi";

&user;
&datum_finden;
&daten_einlesen;
&daten_verwalten;
&grafik_erstellen;
&grafik_anzeigen;

sub user {

$data=$ENV{'QUERY_STRING'};
@fields = split(/&/,$data);
foreach $fields(@fields){
  ($field_name,$field_val)=split(/=/,$fields);
 $field_val=~ tr/+/ /;
 $field_val=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
 $DATA{$field_name}=$field_val;
}

$usr = $DATA{'user'};
$in{'user_username'} = $usr;
# 0 = nicht tansparent - 1 = Transparent
$transparent = "0";
# Farben (RGB)
$transparente_farbe = "0,0,0";


if ($user_verzeichnisse eq '1') {
$user_pfad = "$user_path/$in{'user_username'}/$in{'user_username'}.settings"
}
else
{
$user_pfad = "$user_path/$in{'user_username'}.settings"
}


@Zeilen = ("");
open(MAILDAT, "<$user_pfad") or &fehler("Username nicht gefunden.");
($user_name, $user_username, $user_email, $user_homepage, $user_pw1, $design, $counterstellen) = <MAILDAT>;
close(MAILDAT);

chop ($user_name);
chop ($user_username);
chop ($user_email);
chop ($user_homepage);
chop ($user_pw1);
chop ($design);
chop ($counterstellen);

if ($user_verzeichnisse eq '1') {
$user_path = "$user_path/$in{'user_username'}";
}

$top_dat = "$user_path/$in{'user_username'}.top.dat";
$count_dat = "$user_path/$in{'user_username'}.count.dat";
$logged_dat = "$user_path/$in{'user_username'}.logged_ips.dat";
$fly_temp = "$usr.fly2.temp";
$last_dat = "$user_path/$in{'user_username'}.last.dat";


}

sub daten_einlesen {
	open(TOPCOUNT,"<$top_dat");
		$top_count = <TOPCOUNT>;
	close(TOPCOUNT);

	open(COUNTDAT,"<$count_dat") or &fehler("Kann <b>$count_dat</b> nicht lesen.");
		$count_data = <COUNTDAT>;
	close(COUNTDAT);

	open(COUNTDAT,"<$last_dat") or &fehler("Kann <b>$last_dat</b> nicht lesen.");
		$last_data = <COUNTDAT>;
	close(COUNTDAT);

	open(WOCHENTAG,"<$user_path/$in{'user_username'}.$wochentag.dat") or &fehler("Kann <b>$wochentag.dat</b> nicht lesen.");
		$wochentagdata = <WOCHENTAG>;
	close(WOCHENTAG);

	($heute_data,$tag_jahr) = split (/\|/, $wochentagdata);

	$gestern=$wochentag;
	$gestern--;
	if ($gestern < 0) {$gestern=6};

	## die Hits von gestern
	open(WOCHENTAG,"<$user_path/$in{'user_username'}.$gestern.dat") or &fehler("Kann <b>$wochentag.dat</b> nicht lesen.");
		$wochentagdata = <WOCHENTAG>;
	close(WOCHENTAG);
  
	($gestern_data,$tag_jahr) = split (/\|/, $wochentagdata);



}

sub daten_verwalten {
	foreach $wochentage (0..6) {
		open(WOCHENTAG,"<$user_path/$in{'user_username'}.$wochentage.dat");
			$wochentagdata = <WOCHENTAG>;
		close(WOCHENTAG);

		($counter_tag,$tag_jahr) = split (/\|/, $wochentagdata);
		push (@statistik,"$counter_tag $wochentage");
		push (@sieben_tage,"$counter_tag ");
	}

	@sortierte_statistik = sort sortierung @statistik;

	$i=0;
	$schnitt=0;
	$datum=0;
	$sieben_tage=0;

	foreach $datum (@sieben_tage) {
	$datum=~ s/ //;
	if ($i eq '0') {$sieben_tage = $datum;}
	else {
	$sieben_tage = $sieben_tage . '/' . $datum;
	}
	$schnitt= $schnitt+$datum;
	$i++;
	};

	$schnitt = $schnitt / 7;
	$schnitt = sprintf("%.2f",$schnitt);

	($a) = split (/ /,@sortierte_statistik[6]);

	$beginn = 0;
	foreach $wochentage (0..6) {
		$beginn++;
	if ($beginn > 6) {
		$beginn = 0;
	}
	($counter,$tag_2) = split (/ /,$statistik[$beginn]);
	$prozent=int(($counter / $a) * 100);
	push (@auswertung_statistik,"$tag_2 $counter $prozent");
}
}

exit;

sub sortierung {
	if($a < $b) {
		return -1;
	}
	elsif($a == $b) {
		return 0;
	}
	else {
		return 1;
	}
}

sub grafik_erstellen {
	$fly_temp = "$user_path/$in{'user_username'}.fly.counter2.temp";
	open(FLY,">$fly_temp");
	print FLY "new\n";
	print FLY "size 500,350\n";
	print FLY "fill 2,2,0,0,0\n";
	print FLY "rect 1,1,498,15,255,255,255\n";
	print FLY "string 255,255,255,4,2,medium,Statistik fr $user_homepage\n";
	print FLY "string 255,255,255,2,20,medium,Eingetragene URL:\n";
	print FLY "string 255,0,0,210,20,medium,$user_homepage\n";

	print FLY "string 255,255,255,2,40,medium,Counterstand laut Datenbank:\n";
	print FLY "string 255,0,0,210,40,medium,$count_data\n";
	print FLY "string 255,255,255,2,60,medium,Zugriffe heute:\n";
	print FLY "string 255,0,0,210,60,medium,$heute_data\n";

	print FLY "string 255,255,255,2,80,medium,Zugriffe gestern:\n";
	print FLY "string 255,0,0,210,80,medium,$gestern_data\n";

	print FLY "string 255,255,255,2,100,medium,Rekord:\n";
	print FLY "string 255,0,0,210,100,medium,$top_count\n";

	print FLY "string 255,255,255,2,120,medium,Letzter Zugriff:\n";
	print FLY "string 255,0,0,210,120,medium,$last_data\n";

	print FLY "string 255,255,255,2,140,medium,Zugriffe der letzten 7 Tage:\n";
	print FLY "string 255,0,0,210,140,medium,$sieben_tage\n";

	print FLY "string 255,255,255,2,160,medium,Durchschnittliche Hits:\n";
	print FLY "string 255,0,0,210,160,medium,$schnitt\n";

	$anfang = 202;
	$anfangtext = 200;
	$ende = 210;
	$ende_counter = 420;

	foreach $wochentage (0..6) {
	($tag_temp,$counter,$prozent) = split (/ /,@auswertung_statistik[$wochentage]);
	$prozent = ($prozent * 2) + 2;
	$prozent = $prozent + 210;
	if ($prozent < 21) {
		$prozent = 21;
	}
		$farbe_counter = 200;
		if ($top_count eq $counter) {$farbe_counter = 255;};

	if ($tag_temp eq $wochentag) {
		print FLY "frect 210,$anfang,$prozent,$ende,0,0,255\n";
		print FLY "string 255,255,255,180,$anfangtext,medium,$tage[$tag_temp]\n";
		print FLY "string 0,0,$farbe_counter,$ende_counter,$anfangtext,medium, $counter\n";
	}
	else {
		print FLY "frect 210,$anfang,$prozent,$ende,255,0,0\n";
		print FLY "string 255,255,255,180,$anfangtext,medium,$tage[$tag_temp]\n";
		print FLY "string 0,0,$farbe_counter,$ende_counter,$anfangtext,medium, $counter\n";
	}
                  
		$anfang = $anfang + 15;
		$anfangtext = $anfangtext +15;
		$ende = $ende + 15;
	}
	print FLY "rect 1,333,498,348,255,255,255\n";
	print FLY "string 255,255,255,4,335,medium,Made by D-oh-Counter (www.d-oh.de)\n";
	close(FLY);

}

sub grafik_anzeigen {
print "MIME Version: 1.0\n";
print "Content-type: image/gif\n";
print "Cache-Control: no-cache\n";
print "Pragma: no-cache\n";
print "expires: 0\n\n";
	print `$fly_proggy -q -i $fly_temp`;
}

sub datum_finden {
	@tage   = ('So','Mo','Di','Mi','Do','Fr','Sa');
	($sekunden, $minuten, $stunden, $tag, $monat, $jahr, $wochentag, $tage_jahr) = localtime(time);
}

sub fehler {
	print "Content-type: text/html\n\n";   
	print "<html><head><title>D-oh-Counter Fehler</title></head><body>\n";
	print "Ein Fehler ist aufgetreten: <br>@_<br>\n";
	print "<br></body></html>\n";
	exit;
}
